clc; clear all

A = [ 1 1 1 1; 2 1 1 1; 3 2 1 2 ; 3 1 1 1 ];
b = [ 1;1 ;1 ;1  ];

% A=[1 0 ;1 1]
% b=[1;1]

[A0,b0] = Reduktion(A,b)




function [A0,b0] = Reduktion(A,b)

[m,n]=size(A);

%QR-Zerlegung
[Q,R,E] = qr(A);

%Groesse der Dreiecksmatrix
p=1;
for i=1:min(n,m)
   p=i;
   if norm(R(i,i)) < 10^(-10)
      p=i-1;
      break
   end
end


%ungekuerztes b0
b0 = Q'*b;

%Test auf Loesbarkeit
for i=1:m-p
   if norm(b0(i+p)) > 10^(-10)
      disp('LGS nicht loesbar')
      return
   end
end

%ungekuertes A0
A0 = R*E';

%Kuerzung
A0 = A0(1:p,1:n);
b0 = b0(1:p);


end


